import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public abstract class Game extends Actor {
    
    protected static int LAST_ID;
    
    protected int id = LAST_ID++;
    protected int ticksAlive;
    protected boolean firstAct;
    
    @Override
    public final void act() {
        if (firstAct = (ticksAlive++ == 0)) {
            firstAct();
        }
        
        doAct();
    }
    
    public void firstAct() {}
    public void doAct() {}
    
    public Map getMap() {
        return getWorld() instanceof Map ? (Map) getWorld() : null;
    }
    
    public int getFieldCenterX() {
        return getX() - ((getX() - getMap().getOffset() + 16) % 32) + 16;
    }
    
    public int getFieldCenterY() {
        return getY() - getY() % 32 + 16;
    }
    
    public void moveToFieldCenter() {
        this.setLocation(getFieldCenterX(), getFieldCenterY());
    }
    
    public int getId() {
        return id;
    }
}
