import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.Set;
import java.util.HashSet;

/**
 * Write a description of class Hitbox here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hitbox extends Game
{
    private boolean visible;
    private Actor source;

    public Hitbox(int width, int height, Actor source){
        setImage(new GreenfootImage(width, height));
        getImage().fill();
        getImage().setTransparency(0);

        this.source = source;
    }

    @Override
    public void doAct() {
        if (visible != getMap().areHitboxesVisible()) {
            getImage().setTransparency((visible = getMap().areHitboxesVisible()) ? 125 : 0);
        }
    }

    public List<Actor> getIntersections(){
        return getIntersectingObjects(null);
    }

    public List<Bomb> getIntersectingBombs(){
        return getIntersectingObjects(Bomb.class);
    }

    public Item getOneIntersectingItem(){
        return (Item)getOneIntersectingObject(Item.class);
    }

    public Set<Class<? extends Actor>> getIntersectingTypes() {
        Set<Class<? extends Actor>> actors = new HashSet<>();
        for (Actor actor : getIntersections()) {
            actors.add(actor.getClass());
        }

        return actors;
    }

    public void move(int deltaX, int deltaY) {
        this.setLocation(getX() + deltaX, getY() + deltaY);
    }

    public Actor getSource(){
        return source;
    }
}
