import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 * Write a description of class Multi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LAN extends Multiplayer implements Runnable
{
    private boolean isHost;
    private boolean active = true;
    private int port = 4001;
    private boolean firstActAfterConnection = true;
    private SimpleButton menu = new SimpleButton("Menu");
    private int playerPositionIndex;
    private int chosenCharacter;
    private MapTemplate mapTemplate;
    private ObjectInputStream ois;
    private ObjectOutputStream oos;

    //isHost == true

    private static ServerSocket serverSocket;
    private Menupanel hostPanel;
    private ArrayList<Socket> connectedSockets;
    private String[] hostText;
    private MenuButton play;

    //isHost == false

    private Socket socket;
    private static ArrayList<String> lastIps = new ArrayList<String>();
    private static boolean hasAlreadySomeUsedIPs = false;
    private boolean hasConnected = false;
    private boolean firstConnectedAct = true;
    private Menupanel joinPanel;
    private Textfield ipTextfield;
    private String[] joinText;

    public LAN(boolean isHost, MapTemplate mapTemplate) // if host
    {
        super(800, 600, 1);

        this.isHost = isHost;
        this.mapTemplate = mapTemplate;
        
        try{
            this.hostText = new String[]{"Your IP-address:",InetAddress.getLocalHost().getHostAddress(),"","People who have joined:","","","",""};
            this.hostPanel = new Menupanel(hostText,13,true,50);
        }catch(UnknownHostException e){e.printStackTrace();}

        this.connectedSockets = new ArrayList<Socket>();

        try{
            if (serverSocket != null)
                serverSocket.close();
            this.serverSocket = new ServerSocket(port);
        }catch(IOException e){e.printStackTrace();}

        addObject(hostPanel, getWidth()/2, getHeight()/2);

        addObject(menu, 37, 13);

        new Thread(this).start();
        
        //connect to localhost......
        try{
            socket = new Socket("localhost", port);
        }catch(Exception e){e.printStackTrace();System.out.println("Couldn't connect to localhost??");}
        
        play = new MenuButton(4);
        addObject(play, getWidth()/2, getHeight()-64);

    }

    public LAN(boolean isHost) // if join
    {
        super(800, 600, 1);
        makeJoinGUI(false, "");
        this.isHost = isHost;
        addObject(menu, 37, 13);
    }

    public void act(){
        if (Greenfoot.mouseClicked(menu)){
            Greenfoot.setWorld(new Menu());
        }

        if (isHost){
            if (Greenfoot.mousePressed(play)){
                active = false;
                new Thread(() -> {new GameHost(mapTemplate, connectedSockets);}).start();
                makeInfoThread();
            }

            // if this instance is host
        }else{
            // if this instance is the joining client
            if (!hasConnected){
                // if the client has not yet connected
                if (hasAlreadySomeUsedIPs){
                    boolean hoverOverSomething = false;
                    for (int i = 0; i < joinText.length-7; i++)
                        if (joinPanel.hoverOverLine(i+1)){
                            joinPanel.selectLine(i+1);
                            hoverOverSomething = true;
                            if (Greenfoot.mousePressed(null)){
                                try{
                                    socket = new Socket(joinPanel.getLine(i+1), port);
                                    System.out.println("Client hat verbunden");
                                    hasConnected = true;
                                }catch(Exception e){
                                    e.printStackTrace();
                                    joinText[4] = "Could not connect.. try again?";
                                    joinPanel.writeText(joinText);
                                }
                            }
                        }
                    if (joinPanel.hoverOverLine(joinText.length-1)){
                        joinPanel.selectLine(joinText.length-1);
                        hoverOverSomething = true;
                        if (Greenfoot.mousePressed(null)){
                            try{
                                if (!lastIps.contains(ipTextfield.getText())){
                                    lastIps.add(0,ipTextfield.getText());
                                    if (lastIps.size() == 11)
                                        lastIps.remove(10);
                                }
                                socket = new Socket(ipTextfield.getText(), port);
                                System.out.println("Client hat verbunden");
                                hasConnected = true;
                            }catch(Exception e){
                                e.printStackTrace();
                                joinText[4] = "Could not connect.. try again?";
                                joinPanel.writeText(joinText);
                            }
                            removeObject(ipTextfield);
                            removeObject(joinPanel);
                            makeJoinGUI(ipTextfield.active,ipTextfield.getText());
                        }
                    }
                    if (!hoverOverSomething)
                        joinPanel.selectLine(-1);
                }else{
                    if (joinPanel.hoverOverLine(4)){
                        joinPanel.selectLine(4);
                        if (Greenfoot.mousePressed(null)){
                            try{
                                if (!lastIps.contains(ipTextfield.getText())){
                                    lastIps.add(0,ipTextfield.getText());
                                    if (lastIps.size() == 11)
                                        lastIps.remove(10);
                                }
                                socket = new Socket(ipTextfield.getText(), port);
                                System.out.println("Client hat verbunden");
                                hasConnected = true;
                            }catch(Exception e){
                                e.printStackTrace();
                                joinText[4] = "Could not connect.. try again?";
                                joinPanel.writeText(joinText);
                            }
                            removeObject(ipTextfield);
                            removeObject(joinPanel);
                            makeJoinGUI(ipTextfield.active,ipTextfield.getText());
                        }
                    }else
                        joinPanel.selectLine(-1);
                }
            }else{
                // if the client has connected
                if (firstConnectedAct){
                    try{
                        oos = new ObjectOutputStream(socket.getOutputStream());
                        ois = new ObjectInputStream(socket.getInputStream());
                    }catch(Exception e){e.printStackTrace();}
                    
                    firstConnectedAct = false;
                    joinPanel.writeLine("Waiting for start...", joinText.length-1);
                    
                    makeInfoThread();
                }
            }
        }
    }

    public void run(){
        if (isHost){
            // if this instance is host
            Socket s;
            try{
                while ((s = serverSocket.accept()) != null) {
                    connectedSockets.add(s);
                    for (int i = 0; i < connectedSockets.size(); i++)
                        hostText[i+4] = connectedSockets.get(i).getLocalAddress()+"";
                    System.out.println("got connection from: "+ s.getLocalAddress());
                    hostPanel.writeText(hostText);
                    
                    if (isHost)
                        playerPositionIndex = 0;
                    else{
                        Thread.sleep(100);
                        oos.writeInt(connectedSockets.size()-1);
                        oos.flush();
                        ///dos.close();
                    }
                }
            }catch(Exception e){e.printStackTrace();}
        }else{
            // if this instance is the joining client

        }
    }

    private void makeJoinGUI(boolean fieldIsActive, String fieldText){
        if (lastIps.size() > 0)
        {
            hasAlreadySomeUsedIPs = true;

            joinText = new String[7+lastIps.size()];
            joinText[0] = "Last IPs used:";

            for (int i = 0; i < lastIps.size(); i++)
                joinText[i+1] = lastIps.get(i);

            joinText[lastIps.size()+1] = "";
            joinText[lastIps.size()+2] = "... or insert IP of a new host:";
            joinText[lastIps.size()+3] = "";
            joinText[lastIps.size()+4] = "";
            joinText[lastIps.size()+5] = "";
            joinText[lastIps.size()+6] = "connect!";
        }else{
            joinText = new String[]{"Insert IP of a host please..","","","","connect!"};
        }
        this.joinPanel = new Menupanel(joinText,13,true,50);
        addObject(joinPanel, getWidth()/2, getHeight()/2);

        ipTextfield = new Textfield(15,24,fieldIsActive,fieldText);
        addObject(ipTextfield, getWidth()/2, hasAlreadySomeUsedIPs ? joinPanel.getY()-joinPanel.getImage().getHeight()/2+50+25+lastIps.size()*25+87 : joinPanel.getY()-joinPanel.getImage().getHeight()/2+50+62);
    }
    
    private void makeInfoThread(){
        new Thread(() ->{  
                            try{
                                if (oos == null){
                                    oos = new ObjectOutputStream(socket.getOutputStream());
                                    ois = new ObjectInputStream(socket.getInputStream());
                                }
                                
                                if (!isHost)
                                    playerPositionIndex = ois.readInt(); // game starts if instance recieves this
                                else
                                    ois.readInt();
                                System.out.println("Player's position: " + playerPositionIndex);
                                
                                oos.writeInt(chosenCharacter); // give the host the chosen player
                                oos.flush();
                                
                                //dos.writeString("playername"); // give the host the own name
                                //dos.flush();
                                
                                ///dis.close();
                                ///dos.close();
                                
                                int chosenCharacter = ois.readInt();
                                
                                int playercount = ois.readInt();
                                
                                mapTemplate = (MapTemplate) ois.readObject();
                                
                                LocalPlayer.outToServer = oos;
                                LocalPlayer.inFromServer = ois;
                                
                                Greenfoot.setWorld(new OnlineMap(mapTemplate, playercount, playerPositionIndex, chosenCharacter, socket, ois, oos));
                                
                            }catch(Exception e){e.printStackTrace();}
                        }).start();
    }
}
