import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class LevelMaker here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class LevelMaker extends Editor
{
    public static String style;
    private Menupanel editorBackground;
    private Menupanel editorForeground;
    private Menupanel savingDialog = new Menupanel(new String[]{"Please pick a name for your map","and hit save.","","","","save","abort"}, 7, true, 50);
    private GrayTransparentBackground transparentWall;
    private Textfield textfield;
    private char selected = 'x';
    
    private final Preview d;
    private final Preview b;
    private final Preview p;
    private final Preview empty;
    
    private final SimpleButton menu;
    private final SimpleButton clear;
    
    public static GreenfootImage destroyableBlock;
    public static GreenfootImage block;
    public static GreenfootImage player;
    public static GreenfootImage empty_image;
    
    private final List<FieldOutlining> fieldOutlinings;
    
    public static Preview mouseFollower;

    private boolean mouseIsBeingDragged = false;
    
    private boolean saving = false;
    private boolean mapIsSaved = false;
    
    static{
        new Resources().run();
    }
    
    public LevelMaker(){
        this("Forest");
    }
    
    public LevelMaker(String style)
    {
        super(950, 736, 1);
        
        this.style = style;
        this.transparentWall = new GrayTransparentBackground(getWidth(), getHeight(), 175);
        switch(style){   
            case "Original Bomberman":
                setBackground(new GreenfootImage("original_bomberman_background.png"));
                destroyableBlock = Resources.original_bomberman_destroyableBlock;
                block = Resources.original_bomberman_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
            case "Circle of death":
                setBackground(new GreenfootImage("circle_background.png"));
                destroyableBlock = Resources.circle_destroyableBlock;
                block = Resources.circle_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
                case "Squares of death":
                setBackground(new GreenfootImage("BBC_background2.png"));
                destroyableBlock = Resources.original_bomberman_destroyableBlock;
                block = Resources.square_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
                case "Close Quarter Combat":
                setBackground(new GreenfootImage("BBC_background4.png"));
                destroyableBlock = Resources.original_bomberman_destroyableBlock;
                block = Resources.cqc_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
                case "Labyrinth":
                setBackground(new GreenfootImage("BBC_background1.png"));
                destroyableBlock = Resources.original_bomberman_destroyableBlock;
                block = Resources.labyrinth_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
                case "1v1 me":
                setBackground(new GreenfootImage("BBC_background3.png"));
                destroyableBlock = Resources.original_bomberman_destroyableBlock;
                block = Resources.versus_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
                
            default:
                GreenfootImage bg = new GreenfootImage(Resources.background_menu);
                bg.scale(getWidth(), getHeight());
                setBackground(bg);
                destroyableBlock = Resources.forest_destroyableBlock;
                block = Resources.forest_block;
                player = Resources.characters.get(0)[0];
                empty_image = new GreenfootImage("fieldoutlining.png");
                break;
        }

        setUpWorld();
        
        fieldOutlinings  = getObjects(FieldOutlining.class);
        
        editorBackground = new Menupanel(new String[]{"","","","","","","","","","","",""," save?"}, 3, false,50);
        addObject(editorBackground, 278/2, getHeight()/2+17);
        editorForeground = new Menupanel(new String[]{"Click and place","  the objects","","","","","","","","","","","","","","","","","","","",""}, 2, true,18);
        addObject(editorForeground, 278/2, editorForeground.getImage().getHeight()/2);
        
        mouseFollower = new Preview(32,32, new GreenfootImage(1,1));
        addObject(mouseFollower,0,0);
        
        d = new Preview(64,64,destroyableBlock);
        addObject(d, 278/2, getHeight()/5*1);
        
        addObject(new SimpleButton("Destroyable", 14, 100, 40, 0, 15, 5), 278/2, (getHeight()/5) + d.getImage().getHeight());
        addObject(new SimpleButton("Block", 14, 100, 40, 0, 15, 28), 278/2, (getHeight()/5) + d.getImage().getHeight() + 20);
        
        b = new Preview(64,64,block);
        addObject(b, 278/2, getHeight()/5*2);
        addObject(new SimpleButton("Block", 14, 100, 40, 0, 15, 28), 278/2, (getHeight()/5)*2 + d.getImage().getHeight());
        
        p = new Preview(64,64,player);
        addObject(p, 278/2, getHeight()/5*3);
        addObject(new SimpleButton("Player", 14, 100, 40, 0, 15, 28), 278/2, (getHeight()/5)*3 + d.getImage().getHeight());
        
        empty = new Preview(64,64,empty_image);
        addObject(empty, 278/2, getHeight()/5*4);
        addObject(new SimpleButton("Empty space", 14, 100, 15, 0, 10, 5), 278/2, (getHeight()/5)*4 + d.getImage().getHeight() - 20);        
        
        menu = new SimpleButton("Menu");
        clear = new SimpleButton("Clear", 20, 74, 27, 2, 21, 5);
        addObject(menu, 278/2-45, getHeight()-13);
        addObject(clear, 278/2+45, getHeight()-13);
    }
    
    public void act(){
        if (saving){
            boolean hoverOverSomething = false;
            if(savingDialog.hoverOverLine(5)){
                savingDialog.selectLine(5);
                hoverOverSomething = true;
                if (Greenfoot.mouseClicked(null) && !textfield.getText().isEmpty()){
                    if (saveWorld(textfield.getText())){
                        editorBackground.writeText(new String[]{"","","","","","","","","","","",""," saved"});
                        mapIsSaved = true;
                    }else{
                        editorBackground.writeText(new String[]{"","","","","","","","","","","",""," Error"});
                    }
                    removeObject(transparentWall);
                    removeObject(savingDialog);
                    removeObject(textfield);
                    saving = false;
                }
            }else if(savingDialog.hoverOverLine(6)){
                savingDialog.selectLine(6);
                hoverOverSomething = true;
                if (Greenfoot.mouseClicked(null)){
                    removeObject(transparentWall);
                    removeObject(savingDialog);
                    removeObject(textfield);
                    saving = false;
                }
            }
            if (hoverOverSomething == false)
                savingDialog.selectLine(-1);
        }else{
            if(editorBackground.hoverOverLine(12)){
                editorBackground.selectLine(12);
                if (Greenfoot.mouseClicked(null)){
                    saving = true;
                    addObject(transparentWall, getWidth()/2, getHeight()/2);
                    addObject(savingDialog, getWidth()/2, getHeight()/2);
                    textfield = new Textfield();
                    addObject(textfield, getWidth()/2, getHeight()/2-12);
                }
            }else{
                editorBackground.selectLine(-1);
            }

        
            if (Greenfoot.mouseClicked(d)){
                selected = 'd';
                mouseFollower.setNewImage(destroyableBlock);
                return;
            }else if (Greenfoot.mouseClicked(b)){
                selected = 'b';
                mouseFollower.setNewImage(block);
                return;
            }else if (Greenfoot.mouseClicked(p)){
                selected = 'p';
                mouseFollower.setNewImage(player);
                return;
            }else if (Greenfoot.mouseClicked(empty)){
                selected = ' ';
                mouseFollower.setNewImage(empty_image);
                return;
            }else if (Greenfoot.mouseClicked(menu)){
                Greenfoot.setWorld(new Menu());
                return;
            }else if (Greenfoot.mouseClicked(clear)){
                for (FieldOutlining field : fieldOutlinings){
                    field.setValue(' ');
                }
                return;
            }
        
            if ("escape".equals(Greenfoot.getKey())){
                mouseFollower.setNewImage(new GreenfootImage(1,1));
                selected = 'x';
            }
        
            MouseInfo mouse = Greenfoot.getMouseInfo();
        
            if (mouse != null){
                mouseFollower.setLocation(mouse.getX(), mouse.getY());
                if (mouse.getX() > 278){
                    if (Greenfoot.mousePressed(null) || mouseIsBeingDragged){
                        mouseIsBeingDragged = true;
                        List<FieldOutlining> f = (List<FieldOutlining>) getObjectsAt(mouse.getX(), mouse.getY(), FieldOutlining.class);
                        if (f.size() > 0){
                            f.get(0).setValue(selected);
                            if (mapIsSaved){
                                mapIsSaved = false;
                                editorBackground.writeText(new String[]{"","","","","","","","","","","",""," save?"});
                            }
                        }
                    }
                    if (Greenfoot.mouseClicked(null)){
                        mouseIsBeingDragged = false;
                    }
                }
            }
        }
    }
    
    private void setUpWorld(){
        for (int y = 0; y < 23; y++)
            for (int x = 0; x < 21; x++)
                addObject(new FieldOutlining(x,y), x*32+278+16, y*32+16);
        
    }
    
    private boolean saveWorld(String levelName){
        
        char[][] rawMap = new char[23][21];
        
        for (FieldOutlining field : fieldOutlinings){
            rawMap[field.y][field.x] = field.value;
        }
        
        int mapHeight = 0;
        int indexOfFirstChar = 99;
        int indexOfLastChar = 0;
        int indexOfFirstLine = 99;
        int indexOfLastLine = 0;
        int players = 0;
        
        boolean[] hasContent = new boolean[23];
        
        for (int y = 0; y < 23; y++){
            for (int x = 0; x < 21; x++)
                if (rawMap[y][x] != ' ')
                {
                    if (!hasContent[y] && indexOfFirstChar > x)
                        indexOfFirstChar = x;
                    if (indexOfLastChar < x)
                        indexOfLastChar = x;
                    if (!hasContent[y])
                        mapHeight++;
                    if (rawMap[y][x] == 'p')
                        players++;
                    if (indexOfFirstLine > y)
                        indexOfFirstLine = y;
                    if (indexOfLastLine < y)
                        indexOfLastLine = y;
                    hasContent[y] = true;
                }
        }
        for (int y = 0; y < 23; y++){
            if (y > indexOfFirstLine && y < indexOfLastLine && !hasContent[y]){
                hasContent[y] = true;
                mapHeight++;
            }
        }
        
        
        if (players == 0){
            System.out.println("no playerspawn");
            return false;
        }else if (mapHeight <= 3 || indexOfLastChar-indexOfFirstChar+1 <= 3){
            System.out.println("no map was made: too small");
            return false;
        }
        
        char[][] savableMap = new char[mapHeight][indexOfLastChar-indexOfFirstChar+1];
        
        int yIndex = -1;
        for (int y = 0; y < 23; y++){
            if (hasContent[y]){
                yIndex++;
                for (int x = 0; x < indexOfLastChar-indexOfFirstChar+1; x++)
                    savableMap[yIndex][x] = rawMap[y][indexOfFirstChar+x];
            }
        }
        
        Map.maps.put(levelName, new MapTemplate(style, 278+32*(indexOfLastChar-indexOfFirstChar+1), 32*mapHeight, players, savableMap));
        
        // Easily generate new Maps as a creator
        System.out.println("");
        System.out.print("         Map.maps.put(\"" + levelName + "\", new MapTemplate(\"" + style + "\", " + (278+32*(indexOfLastChar-indexOfFirstChar+1)) + ", " + 32*mapHeight + ", " + players + ",\n                new char[][]{");
        for (int y = 0; y < savableMap.length; y++){
            System.out.print("\n                    new char[]{");
            for (int x = 0; x < savableMap[y].length; x++){
                System.out.print("'");
                System.out.print(savableMap[y][x]+"'");
                if (x != savableMap[y].length-1)
                    System.out.print(",");
            }
            System.out.print("}");
            if (y != savableMap.length-1)
                System.out.print(",");
        }
        System.out.print("\n                }));");

        
        return true;
    }
}
