import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MainMenu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MenuButton extends MenuActors
{
    private int imageIndex;
    private int transparency;
    private boolean firstAct = true;
    private boolean mouseOverBefore = false;

    public MenuButton(int imageIndex)
    {
        setImage(Resources.buttons_selected[imageIndex]);
        getImage().setTransparency(0);
        this.imageIndex = imageIndex;
    }

    public void act() 
    {
        if (firstAct){
            firstAct = false;
            getWorld().addObject(new MenuButtonUnselected(), getX(), getY());
        }

        MouseInfo m = Greenfoot.getMouseInfo();
        if (m != null){
            boolean mouseOver = false;
            if (m.getX() >= getX()-getImage().getWidth()/2 && m.getX() <= getX()+getImage().getWidth()/2 && m.getY() >= getY()-getImage().getHeight()/2 && m.getY() <= getY()+getImage().getHeight()/2)
                mouseOver = true;
            if (mouseOver && transparency <= 245){
                transparency += 10;
                getImage().setTransparency(transparency);
                if (!mouseOverBefore && transparency == 100){
                    Greenfoot.playSound("mouseOver.wav");
                    mouseOverBefore = true;
                }
            }else if (!mouseOver && transparency >= 10){
                transparency -= 10;
                getImage().setTransparency(transparency);
                if (mouseOverBefore)
                    mouseOverBefore = false;
            }
        }else if (transparency >= 10){
            transparency -=10;
            getImage().setTransparency(transparency);
            if (mouseOverBefore)
                mouseOverBefore = false;
        }

    }

    public class MenuButtonUnselected extends MenuActors
    {
        private int backgroundTransparency;

        public MenuButtonUnselected()
        {
            setImage(Resources.buttons[imageIndex]);
            getImage().setTransparency(0);
        }

        public void act() 
        {
            if (backgroundTransparency <= 50)
            {
                getImage().setTransparency(5*backgroundTransparency+5);
                backgroundTransparency++;
            }
        }
    }

}