import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.math.*;

/**
 * Write a description of class Menupanel here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Menupanel extends MenuActors
{
    private final GreenfootImage constructedBackground;
    private String[] text;
    private GreenfootImage writtenImage;
    private int selectedLine = -1; //-1 == nothing selected
    private int textSizeMultiplier;
    private int distanceTextToEdge;
    
    public Menupanel(String[] text, int middleElements, boolean smallText, int distanceTextToEdge){
        if (smallText)
            textSizeMultiplier = 1;
        else
            textSizeMultiplier = 2;
        
        this.distanceTextToEdge = distanceTextToEdge;
        GreenfootImage img = new GreenfootImage(2*5+middleElements*5, 2*5+Math.round((float)text.length*textSizeMultiplier/2)*5);
        
        img.drawImage(Resources.menupanel_parts[0], 0, 0);
        for (int x = 0; x < middleElements; x++)
            img.drawImage(Resources.menupanel_parts[1], x*5+5, 0);
        img.drawImage(Resources.menupanel_parts[2], middleElements*5+5, 0);
        
        int verticalMiddleElements = Math.round((float)textSizeMultiplier*text.length/2);
        
        for (int y = 0; y < verticalMiddleElements; y++){
            img.drawImage(Resources.menupanel_parts[3], 0, y*5+5);
            for (int x = 0; x < middleElements; x++)
                img.drawImage(Resources.menupanel_parts[4], x*5+5, y*5+5);
            img.drawImage(Resources.menupanel_parts[5], middleElements*5+5, y*5+5);
        }
        
        img.drawImage(Resources.menupanel_parts[6], 0, verticalMiddleElements*5+5);
        for (int x= 0; x < middleElements; x++)
            img.drawImage(Resources.menupanel_parts[7], x*5+5, verticalMiddleElements*5+5);
        img.drawImage(Resources.menupanel_parts[8], middleElements*5+5, verticalMiddleElements*5+5);
        
        img.scale(img.getWidth()*10, img.getHeight()*10);
        this.constructedBackground = new GreenfootImage(img);
        this.text = text;
        
        writeText(text);
    }
    
    public void writeText(String[] text){
        this.text = text;
        
        GreenfootImage img = new GreenfootImage(constructedBackground);
        img.setFont(new greenfoot.Font(Font.MONOSPACED, true, false, 18*textSizeMultiplier));
        for (int i = 0; i < text.length; i++)
            img.drawString(text[i], distanceTextToEdge, i*textSizeMultiplier*25+50+textSizeMultiplier*19);
            
        this.writtenImage = img;
        setImage(img);
        
        selectLine(selectedLine);
    }
    
    public boolean hoverOverLine(int index){
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null)
            if (mouse.getY() > getY()-getImage().getHeight()/2+25*textSizeMultiplier*index+50 && mouse.getY() < getY()-getImage().getHeight()/2+25*textSizeMultiplier*(1+index)+50
                && mouse.getX() > getX()-getImage().getWidth()/2 && mouse.getX() < getX()+getImage().getWidth()/2){
                    return true;
            }
        return false;
    }
    
    public void selectLine(int index){
        if (index != -1){
            GreenfootImage img = new GreenfootImage(writtenImage);
            img.setColor(Color.GRAY);
            img.fillRect(10, 25*textSizeMultiplier*index+50, getImage().getWidth()-20, textSizeMultiplier*25);
            img.setFont(new greenfoot.Font(Font.MONOSPACED, true, false, textSizeMultiplier*18));
            img.setColor(Color.WHITE);
            img.drawString(text[index], distanceTextToEdge, index*textSizeMultiplier*25+50+textSizeMultiplier*19);
        
            setImage(img);
        }
        else if (selectedLine != -1)
            setImage(writtenImage);
            
        this.selectedLine = index;
    }
    
    public void writeLine(String s, int index){
        text[index] = s;
        writeText(text);
    }
    
    public String getLine(int index){
        return text[index];
    }
}
