import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Multiplayer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Multiplayer extends Menus
{
    private boolean firstActForState = true;
    private boolean firstAct = true;
    private Menupanel panel;
    private SimpleButton menu;

    private String state = "localorlan";

    private String[] mapnames = Map.maps.keySet().toArray(new String[0]); 
    private String[] displayed;
    private MapTemplate chosenMap; //-1 == not chosen
    private boolean online;

    public Multiplayer()
    {
        super(800, 600, 1);
    }

    protected Multiplayer(int worldWidth, int worldHeight, int cellSize){
        super(worldWidth, worldHeight, cellSize);
        GreenfootImage img = new GreenfootImage(Resources.background_menu);
        img.scale(getWidth(), getHeight());
        setBackground(img);

        setPaintOrder(new Class[] { MenuButton.class, MenuButton.MenuButtonUnselected.class });
    }

    protected Multiplayer(int worldWidth, int worldHeight, int cellSize, boolean bounded){
        super(worldWidth, worldHeight, cellSize, bounded);
        GreenfootImage img = new GreenfootImage(Resources.background_menu);
        img.scale(getWidth(), getHeight());
        setBackground(img);

        setPaintOrder(new Class[] { MenuButton.class, MenuButton.MenuButtonUnselected.class });
    }

    public void act(){
        if (firstAct){
            firstAct = false;
            menu = new SimpleButton("Menu");
            addObject(menu, 37, 13);
        }

        if (Greenfoot.mouseClicked(menu)){
            Greenfoot.setWorld(new Menu());
        }

        switch(state)
        {
            case "mapchoosing":
            if (firstActForState){
                firstActForState = false;

                displayed = new String[mapnames.length+2];
                displayed[0] = "Select a map:";
                displayed[1] = "";
                for (int i = 0; i < mapnames.length; i++)
                    displayed[i+2] = mapnames[i];

                panel = new Menupanel(displayed, 7, true,50);
                addObject(panel, getWidth()/2, getHeight()/2);
            }
            boolean isOverSomething = false;
            for (int i = 0; i < mapnames.length; i++)
                if(panel.hoverOverLine(i+2)){
                    panel.selectLine(i+2);
                    isOverSomething = true;
                    if (Greenfoot.mouseClicked(null)){
                        chosenMap = Map.maps.get(mapnames[i]);
                        if (online)
                            Greenfoot.setWorld(new LAN(true, chosenMap));
                        state = "players";
                        firstActForState = true;
                        removeObject(panel);
                        break;
                    }
                }
            if (!isOverSomething)
                panel.selectLine(-1);
            break;

            case "localorlan":
            if (firstActForState){
                firstActForState = false;

                panel = new Menupanel(new String[]{"Do you want to play", "local or on LAN?", "","Local","LAN -not finished & download first"}, 7, true,50);
                addObject(panel, getWidth()/2, getHeight()/2);
            }
            boolean isOverSomething2 = false;
            if(panel.hoverOverLine(3)){
                panel.selectLine(3);
                isOverSomething2 = true;
                if (Greenfoot.mouseClicked(null)){
                    state = "mapchoosing";
                    firstActForState = true;
                    removeObject(panel);
                    break;
                }
            }
            if(panel.hoverOverLine(4)){
                panel.selectLine(4);
                isOverSomething2 = true;
                if (Greenfoot.mouseClicked(null)){
                    state = "hostorjoin";
                    online = true;
                    firstActForState = true;
                    removeObject(panel);
                    break;
                }
            }
            if (!isOverSomething2)
                panel.selectLine(-1);
            break;

            case "players":
            if (firstActForState){
                firstActForState = false;

                displayed = new String[chosenMap.maxPlayers >= 4 ? 2+4 : 2+chosenMap.maxPlayers];

                displayed[0] = "How many players?";
                displayed[1] = "";

                if (chosenMap.maxPlayers >= 4)
                    for (int i = 0; i < 4; i++)
                        displayed[i+2] = (i+1)+"";
                else
                    for (int i = 0; i < chosenMap.maxPlayers; i++)
                        displayed[i+2] = (i+1)+"";

                panel = new Menupanel(displayed, 7, true,50);
                addObject(panel, getWidth()/2, getHeight()/2);
            }
            boolean isOverSomething3 = false;
            for (int i = 0; i < displayed.length-2; i++)
                if(panel.hoverOverLine(i+2)){
                    panel.selectLine(i+2);
                    isOverSomething3 = true;
                    if (Greenfoot.mouseClicked(null)){
                        Greenfoot.setWorld(new Local(chosenMap, i+1));
                    }
                }
            if (!isOverSomething3)
                panel.selectLine(-1);
            break;

            case "hostorjoin":
            if (firstActForState){
                firstActForState = false;

                panel = new Menupanel(new String[]{"Do you want to be" , "the host or join someone?", "", "Host","Join"}, 7, true,50);
                addObject(panel, getWidth()/2, getHeight()/2);
            }
            boolean isOverSomething4 = false;
            if(panel.hoverOverLine(3)){
                panel.selectLine(3);
                isOverSomething4 = true;
                if (Greenfoot.mouseClicked(null)){
                    online = true;
                    state = "mapchoosing";
                    firstActForState = true;
                    removeObject(panel);
                    break;
                }
            }
            if(panel.hoverOverLine(4)){
                panel.selectLine(4);
                isOverSomething4 = true;
                if (Greenfoot.mouseClicked(null)){
                    Greenfoot.setWorld(new LAN(false));
                }
            }
            if (!isOverSomething4)
                panel.selectLine(-1);
            break;
        }
    }
}
