import java.util.*;
import java.util.Map;
import greenfoot.*;
import greenfoot.sound.*;
import greenfoot.util.*;
import java.util.function.Function;

public class Sounds {

    private static Map<String, Set<GreenfootSound>> sounds = new HashMap<>();
    private static Map<String, String> soundNameToPath = new HashMap<>();

    static {
        Function<GreenfootSound, Set<GreenfootSound>> newSet = sound -> {
            Set<GreenfootSound> set = new HashSet<GreenfootSound>();
            set.add(sound);
            return set;
        };
        
        for (String sound : GreenfootUtil.getSoundFiles()) {
            String name = sound.split("\\.")[0];
            sounds.put(name, newSet.apply(new GreenfootSound(sound)));
            soundNameToPath.put(name, sound);
        }
    }

    public static void load() {} // to force static block call

    public static synchronized GreenfootSound get(String name) {
        Set<GreenfootSound> sounds = Sounds.sounds.get(name);
        
        for (GreenfootSound sound : sounds) {
            if (!sound.isPlaying()) return sound;
        }

        if (sounds.size() == 0) return null;
        GreenfootSound sound = new GreenfootSound(soundNameToPath.get(name));
        sounds.add(sound);
        
        return sound;
    }

    public static GreenfootSound get(String name, int volume) {
        GreenfootSound sound = get(name);
        sound.setVolume(volume);
        return sound;
    }
}